/**
 * WPPA Upload block
 *
 * Version: 8.2.02.004
 */

jQuery(document).ready(function(){
( function ( blocks, editor, i18n, element, components, _, blockEditor ) {

	var el = element.createElement;
	var RichText = blockEditor.RichText;
	var useBlockProps = blockEditor.useBlockProps;
	var wppaUploadAlbumList = wppaAlbumList.slice();
	wppaUploadAlbumList[0] = { label: wppaTextAlbumSelect, value: "0" };

	blocks.registerBlockType( 'wp-photo-album-plus/upload', {
		title: wppaTextUpload,
		icon: el( 'img', {
							src: 	wppaImageDirectory+'camera32.png',
							style: 	{ width: '24px', height: '24px' },
						} ),
		category: 'layout',
		attributes: {
			widgetTitle: {
				type: 'string',
				selector: 'h2',
			},
			wppaAlbum: {
				type: 'number',
				value: 0,
			},
			wppaLoginOnly: {
				type: 'boolean',
				checked: false,
			},
			wppaAdminOnly: {
				type: 'boolean',
				checked: false,
			},
			wppaShortcode: {
				type: 'string',
				value: '[wppa type="upload"]',
			}
		},

		edit: function( props ) {
			var blockProps = wp.blockEditor.useBlockProps();
			var attributes = props.attributes;

			return el(
				'div',
				blockProps,
				el('h2',null,wppaTextUploadForm),
				wppaOnWidgets() ?
				el( RichText, {
					tagName: 'h3',
					placeholder: wppaTextEnterWidgetCaption,
					value: attributes.widgetTitle,
					onChange: function ( value ) {
						props.setAttributes( { widgetTitle: value } );
					},
				}) : null,
				el(
					wp.components.SelectControl,
					{
						help: wppaTextUploadHelp,
						value: props.attributes.wppaAlbum,
						options: wppaUploadAlbumList,
						onChange: function( val ) {
							props.setAttributes( { wppaAlbum: parseInt(val) } );
							props.setAttributes( { wppaShortcode: evaluate(props) } );
						},
					}
				),
				( ! attributes.wppaAdminOnly ?
					el( wp.components.CheckboxControl, {
						label: wppaTextLoginOnly,
						checked: attributes.wppaLoginOnly,
						onChange: function ( value ) {
							props.setAttributes( { wppaLoginOnly: value } );
						},
					}) : null
				),
				el( wp.components.CheckboxControl, {
					label: wppaTextAdminOnly,
					checked: attributes.wppaAdminOnly,
					onChange: function ( value ) {
						props.setAttributes( { wppaAdminOnly: value } );
						if ( value ) {
							props.setAttributes( { wppaLoginOnly: false } );
						}
					},
				}),
				el('small',null,wppaTextCorrShortcode+': '+ evaluate(props)),
			);
		},

		save: function( props ) {
			var attributes = props.attributes;

			return el(
				'div',
				{},
				el('h3',{},attributes.widgetTitle),
				el('div',{},evaluate(props)),
			);
		}
	} );

	function evaluate( props ) {
		var attributes = props.attributes;

		var shortcode = '[wppa type="upload"';
		if ( attributes.wppaAlbum ) {
			shortcode += ' album="'+attributes.wppaAlbum+'"';
		}
		if ( attributes.wppaAdminOnly ) {
			shortcode += ' login="admin"';
		}
		else if ( attributes.wppaLoginOnly ) {
			shortcode += ' login="yes"';
		}
		if ( wppaOnWidgets() ) {
			shortcode += ' widget="upload"';
		}
		shortcode += ']';

		return shortcode;
	}

} )(
	window.wp.blocks,
	window.wp.editor,
	window.wp.i18n,
	window.wp.element,
	window.wp.components,
	window._,
	window.wp.blockEditor
)});



